# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.contrib.postgres.fields
import django.core.validators
import django.db.models.deletion
from django.db import migrations, models

import authentic2.a2_rbac.fields
import authentic2.a2_rbac.utils
import authentic2.validators


class Migration(migrations.Migration):
    replaces = [
        ('a2_rbac', '0001_initial'),
        ('a2_rbac', '0002_role_external_id'),
        ('a2_rbac', '0003_partial_unique_index_on_name_and_slug'),
        ('a2_rbac', '0004_auto_20150523_0028'),
        ('a2_rbac', '0005_auto_20150526_1406'),
        ('a2_rbac', '0006_auto_20150619_1056'),
        ('a2_rbac', '0007_auto_20150708_1337'),
        ('a2_rbac', '0008_auto_20150810_1953'),
        ('a2_rbac', '0009_partial_unique_index_on_permission'),
        ('a2_rbac', '0010_auto_20160209_1417'),
        ('a2_rbac', '0011_auto_20160209_1511'),
        ('a2_rbac', '0013_auto_20170629_0007'),
        ('a2_rbac', '0014_auto_20170711_1024'),
        ('a2_rbac', '0015_organizationalunit_validate_emails'),
        ('a2_rbac', '0016_auto_20171208_1429'),
        ('a2_rbac', '0017_organizationalunit_user_can_reset_password'),
        ('a2_rbac', '0018_organizationalunit_user_add_password_policy'),
        ('a2_rbac', '0019_organizationalunit_show_username'),
        ('a2_rbac', '0020_partial_unique_index_on_name'),
        ('a2_rbac', '0021_auto_20200317_1514'),
        ('a2_rbac', '0022_auto_20200402_1101'),
        ('a2_rbac', '0023_role_can_manage_members'),
        ('a2_rbac', '0024_fix_self_admin_perm'),
        ('a2_rbac', '0025_auto_20210622_1132'),
        ('a2_rbac', '0026_add_roleparenting_soft_delete'),
        ('a2_rbac', '0026_organizationalunit_check_required_on_login_attributes'),
        ('a2_rbac', '0027_auto_20211213_0949'),
        ('a2_rbac', '0027_auto_20220331_1521'),
        ('a2_rbac', '0028_ou_home_url'),
        ('a2_rbac', '0029_use_unique_constraints'),
        ('a2_rbac', '0030_organizationalunit_min_password_strength'),
        ('a2_rbac', '0031_new_operation_model'),
        ('a2_rbac', '0032_copy_operations_data'),
        ('a2_rbac', '0033_remove_old_operation_fk'),
        ('a2_rbac', '0034_new_role_fields'),
        ('a2_rbac', '0035_populate_role_fields'),
        ('a2_rbac', '0036_delete_roleattribute'),
    ]

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='Operation',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('slug', models.CharField(max_length=32, unique=True, verbose_name='slug')),
            ],
        ),
        migrations.CreateModel(
            name='OrganizationalUnit',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'uuid',
                    models.CharField(
                        default=authentic2.a2_rbac.utils.get_hex_uuid,
                        max_length=32,
                        unique=True,
                        verbose_name='uuid',
                    ),
                ),
                ('name', models.CharField(max_length=256, verbose_name='name')),
                ('slug', models.SlugField(max_length=256, verbose_name='slug')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                (
                    'username_is_unique',
                    models.BooleanField(blank=True, default=False, verbose_name='Username is unique'),
                ),
                (
                    'email_is_unique',
                    models.BooleanField(blank=True, default=False, verbose_name='Email is unique'),
                ),
                (
                    'default',
                    authentic2.a2_rbac.fields.UniqueBooleanField(verbose_name='Default organizational unit'),
                ),
                (
                    'validate_emails',
                    models.BooleanField(blank=True, default=False, verbose_name='Validate emails'),
                ),
                (
                    'show_username',
                    models.BooleanField(blank=True, default=True, verbose_name='Show username'),
                ),
                (
                    'check_required_on_login_attributes',
                    models.BooleanField(
                        blank=True, default=True, verbose_name='Check required on login attributes'
                    ),
                ),
                (
                    'user_can_reset_password',
                    models.BooleanField(
                        blank=True,
                        choices=[(None, 'System default'), (True, 'Yes'), (False, 'No')],
                        default=None,
                        null=True,
                        verbose_name='Users can reset password',
                    ),
                ),
                (
                    'user_add_password_policy',
                    models.IntegerField(
                        choices=[(0, 'Send reset link'), (1, 'Manual password definition')],
                        default=0,
                        verbose_name='User creation password policy',
                    ),
                ),
                (
                    'clean_unused_accounts_alert',
                    models.PositiveIntegerField(
                        blank=True,
                        default=730,
                        null=True,
                        validators=[
                            django.core.validators.MinValueValidator(
                                30,
                                'Ensure that this value is greater than 30 days, or leave blank for deactivating.',
                            )
                        ],
                        verbose_name='Days after which the user receives an account deletion alert',
                    ),
                ),
                (
                    'clean_unused_accounts_deletion',
                    models.PositiveIntegerField(
                        blank=True,
                        default=760,
                        null=True,
                        validators=[
                            django.core.validators.MinValueValidator(
                                30,
                                'Ensure that this value is greater than 30 days, or leave blank for deactivating.',
                            )
                        ],
                        verbose_name='Delay in days before cleaning unused accounts',
                    ),
                ),
                ('home_url', models.URLField(blank=True, max_length=256, null=True, verbose_name='Home URL')),
                ('logo', models.ImageField(blank=True, upload_to='services/logos', verbose_name='Logo')),
                (
                    'colour',
                    models.CharField(
                        blank=True,
                        max_length=32,
                        null=True,
                        validators=[authentic2.validators.HexaColourValidator()],
                        verbose_name='Colour',
                    ),
                ),
                (
                    'phone_is_unique',
                    models.BooleanField(blank=True, default=False, verbose_name='Phone is unique'),
                ),
            ],
            options={
                'verbose_name': 'organizational unit',
                'verbose_name_plural': 'organizational units',
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='Permission',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('target_id', models.PositiveIntegerField()),
            ],
            options={
                'verbose_name': 'permission',
                'verbose_name_plural': 'permissions',
            },
        ),
        migrations.CreateModel(
            name='Role',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'uuid',
                    models.CharField(
                        default=authentic2.a2_rbac.utils.get_hex_uuid,
                        max_length=32,
                        unique=True,
                        verbose_name='uuid',
                    ),
                ),
                ('slug', models.SlugField(max_length=256, verbose_name='slug')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('name', models.TextField(verbose_name='name')),
                ('details', models.TextField(blank=True, verbose_name='Role details (frontoffice)')),
                (
                    'emails',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.EmailField(max_length=254), default=list, size=None
                    ),
                ),
                ('emails_to_members', models.BooleanField(default=True, verbose_name='Emails to members')),
                ('is_superuser', models.BooleanField(default=False)),
                (
                    'admin_scope_id',
                    models.PositiveIntegerField(
                        blank=True, null=True, verbose_name='administrative scope id'
                    ),
                ),
                ('external_id', models.TextField(blank=True, db_index=True, verbose_name='external id')),
                (
                    'can_manage_members',
                    models.BooleanField(default=True, verbose_name='Allow adding or deleting role members'),
                ),
                (
                    'admin_scope_ct',
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to='contenttypes.contenttype',
                        verbose_name='administrative scope content type',
                    ),
                ),
            ],
            options={
                'verbose_name': 'role',
                'verbose_name_plural': 'roles',
                'ordering': ('ou', 'service', 'name'),
            },
        ),
        migrations.CreateModel(
            name='RoleParenting',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('direct', models.BooleanField(blank=True, default=True)),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='Creation date')),
                ('deleted', models.DateTimeField(null=True, verbose_name='Deletion date')),
                (
                    'child',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='parent_relation',
                        to='a2_rbac.role',
                    ),
                ),
                (
                    'parent',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='child_relation',
                        to='a2_rbac.role',
                    ),
                ),
            ],
            options={
                'verbose_name': 'role parenting relation',
                'verbose_name_plural': 'role parenting relations',
            },
        ),
    ]
