# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):
    replaces = [
        ('a2_rbac', '0037_remove_organizationalunit_min_password_strength'),
        ('a2_rbac', '0038_organizationalunit_phone_is_unique'),
        ('a2_rbac', '0039_set_user_view_permissions_by_ou'),
    ]

    initial = True

    dependencies = [
        ('a2_rbac', '0040_replace'),
        ('custom_user', '0037_replace'),
        ('contenttypes', '0002_remove_content_type_name'),
        ('authentic2', '0051_replace'),
    ]

    operations = [
        migrations.AddField(
            model_name='role',
            name='members',
            field=models.ManyToManyField(blank=True, related_name='roles', to='custom_user.User'),
        ),
        migrations.AddField(
            model_name='role',
            name='ou',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to='a2_rbac.organizationalunit',
                verbose_name='organizational unit',
            ),
        ),
        migrations.AddField(
            model_name='role',
            name='permissions',
            field=models.ManyToManyField(blank=True, related_name='roles', to='a2_rbac.Permission'),
        ),
        migrations.AddField(
            model_name='role',
            name='service',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name='roles',
                to='authentic2.service',
                verbose_name='service',
            ),
        ),
        migrations.AddField(
            model_name='permission',
            name='operation',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, to='a2_rbac.operation', verbose_name='operation'
            ),
        ),
        migrations.AddField(
            model_name='permission',
            name='ou',
            field=models.ForeignKey(
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                related_name='scoped_permission',
                to='a2_rbac.organizationalunit',
                verbose_name='organizational unit',
            ),
        ),
        migrations.AddField(
            model_name='permission',
            name='target_ct',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE, related_name='+', to='contenttypes.contenttype'
            ),
        ),
        migrations.AlterUniqueTogether(
            name='organizationalunit',
            unique_together={('name',), ('slug',)},
        ),
        migrations.AlterUniqueTogether(
            name='roleparenting',
            unique_together={('parent', 'child', 'direct')},
        ),
        migrations.AlterIndexTogether(
            name='roleparenting',
            index_together={('child', 'parent', 'direct')},
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True)),
                fields=('ou', 'service', 'slug'),
                name='slug_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True)),
                fields=('ou', 'service', 'name'),
                name='name_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True), ('service__isnull', True)),
                fields=('ou', 'slug'),
                name='null_service_slug_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True), ('ou__isnull', True)),
                fields=('service', 'slug'),
                name='null_ou_slug_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(
                    ('admin_scope_ct__isnull', True), ('ou__isnull', True), ('service__isnull', True)
                ),
                fields=('slug',),
                name='null_ou_service_slug_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True), ('service__isnull', True)),
                fields=('ou', 'name'),
                name='null_service_name_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(('admin_scope_ct__isnull', True), ('ou__isnull', True)),
                fields=('service', 'name'),
                name='null_ou_name_uniq_idx',
            ),
        ),
        migrations.AddConstraint(
            model_name='role',
            constraint=models.UniqueConstraint(
                condition=models.Q(
                    ('admin_scope_ct__isnull', True), ('ou__isnull', True), ('service__isnull', True)
                ),
                fields=('name',),
                name='null_ou_service_name_uniq_idx',
            ),
        ),
        migrations.AlterUniqueTogether(
            name='role',
            unique_together={('admin_scope_ct', 'admin_scope_id')},
        ),
        migrations.AddConstraint(
            model_name='permission',
            constraint=models.UniqueConstraint(
                condition=models.Q(('ou__isnull', True)),
                fields=('operation', 'target_ct', 'target_id'),
                name='null_ou_uniq_idx',
            ),
        ),
    ]
