# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.contrib.postgres.fields
import django.db.models.deletion
import django.utils.timezone
from django.db import migrations, models


class Migration(migrations.Migration):
    replaces = [('journal', '0001_initial'), ('journal', '0002_event_api')]

    initial = True

    dependencies = [
        ('sessions', '0001_initial'),
        ('custom_user', '0037_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='EventType',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('name', models.SlugField(max_length=256, unique=True, verbose_name='name')),
            ],
            options={
                'verbose_name': 'event type',
                'verbose_name_plural': 'event types',
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='Event',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'timestamp',
                    models.DateTimeField(
                        blank=True,
                        default=django.utils.timezone.now,
                        editable=False,
                        verbose_name='timestamp',
                    ),
                ),
                (
                    'reference_ids',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.BigIntegerField(),
                        null=True,
                        size=None,
                        verbose_name='reference ids',
                    ),
                ),
                (
                    'reference_ct_ids',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.IntegerField(),
                        null=True,
                        size=None,
                        verbose_name='reference ct ids',
                    ),
                ),
                ('data', models.JSONField(null=True, verbose_name='data')),
                ('api', models.BooleanField(default=False, verbose_name='API')),
                (
                    'session',
                    models.ForeignKey(
                        blank=True,
                        db_constraint=False,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to='sessions.session',
                        verbose_name='session',
                    ),
                ),
                (
                    'type',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.PROTECT,
                        to='journal.eventtype',
                        verbose_name='type',
                    ),
                ),
                (
                    'user',
                    models.ForeignKey(
                        blank=True,
                        db_constraint=False,
                        null=True,
                        on_delete=django.db.models.deletion.DO_NOTHING,
                        to='custom_user.user',
                        verbose_name='user',
                    ),
                ),
            ],
            options={
                'verbose_name': 'event',
                'verbose_name_plural': 'events',
                'ordering': ('timestamp', 'id'),
            },
        ),
    ]
