# Generated by Django 3.2.23 on 2023-12-14 21:01

import uuid

import django.contrib.postgres.fields
import django.db.models.deletion
import django.utils.timezone
from django.db import migrations, models

import authentic2.utils.misc
import authentic2.validators


class Migration(migrations.Migration):
    replaces = [
        ('custom_user', '0001_initial'),
        ('custom_user', '0002_auto_20150410_1823'),
        ('custom_user', '0003_auto_20150504_1410'),
        ('custom_user', '0004_user_ou'),
        ('custom_user', '0005_auto_20150522_1527'),
        ('custom_user', '0006_auto_20150527_1212'),
        ('custom_user', '0007_auto_20150610_1527'),
        ('custom_user', '0008_auto_20150617_1606'),
        ('custom_user', '0009_auto_20150810_1953'),
        ('custom_user', '0010_auto_20160307_1418'),
        ('custom_user', '0011_manual_attribute_values_for_name_fields'),
        ('custom_user', '0012_user_modified'),
        ('custom_user', '0013_user_email_verified'),
        ('custom_user', '0014_set_email_verified'),
        ('custom_user', '0015_auto_20170707_1653'),
        ('custom_user', '0016_auto_20180925_1107'),
        ('custom_user', '0017_auto_20200305_1645'),
        ('custom_user', '0018_user_last_account_deletion_alert'),
        ('custom_user', '0019_add_user_deleted'),
        ('custom_user', '0020_deleteduser'),
        ('custom_user', '0021_set_unusable_password'),
        ('custom_user', '0022_index_email'),
        ('custom_user', '0023_index_username'),
        ('custom_user', '0024_index_email_by_trigrams'),
        ('custom_user', '0025_user_deactivation'),
        ('custom_user', '0026_remove_user_deleted'),
        ('custom_user', '0027_user_deactivation_reason'),
        ('custom_user', '0028_user_email_verified_date'),
        ('custom_user', '0029_profile_profiletype'),
        ('custom_user', '0030_auto_20220304_1136'),
        ('custom_user', '0031_profile_email'),
        ('custom_user', '0032_auto_20220919_1230'),
        ('custom_user', '0032_index_deleteduser_old_email'),
        ('custom_user', '0032_index_deleteduser_old_uuid'),
        ('custom_user', '0033_user_keepalive'),
        ('custom_user', '0034_user_email_verified_sources'),
        ('custom_user', '0035_alter_user_username'),
        ('custom_user', '0036_remove_user_constraint_at_least_one_identifier'),
    ]

    initial = True

    dependencies = [
        ('auth', '0012_alter_user_first_name_max_length'),
        ('a2_rbac', '0040_replace'),
        ('authentic2', '0051_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='DeletedUser',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('deleted', models.DateTimeField(auto_now_add=True, verbose_name='Deletion date')),
                ('old_uuid', models.TextField(blank=True, db_index=True, null=True, verbose_name='Old UUID')),
                (
                    'old_user_id',
                    models.PositiveIntegerField(blank=True, null=True, verbose_name='Old user id'),
                ),
                (
                    'old_email',
                    models.EmailField(
                        blank=True, db_index=True, max_length=254, null=True, verbose_name='Old email adress'
                    ),
                ),
                (
                    'old_phone',
                    models.CharField(blank=True, max_length=64, null=True, verbose_name='Old phone number'),
                ),
                ('old_data', models.JSONField(blank=True, null=True, verbose_name='Old data')),
            ],
            options={
                'verbose_name': 'deleted user',
                'verbose_name_plural': 'deleted users',
                'ordering': ('deleted', 'id'),
            },
        ),
        migrations.CreateModel(
            name='ProfileType',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'uuid',
                    models.UUIDField(default=uuid.uuid4, editable=False, unique=True, verbose_name='UUID'),
                ),
                ('name', models.CharField(max_length=64, verbose_name='name')),
                ('slug', models.SlugField(max_length=64, unique=True, verbose_name='slug')),
            ],
            options={
                'verbose_name': 'profile type',
                'verbose_name_plural': 'profile types',
                'ordering': ('name', 'slug'),
            },
        ),
        migrations.CreateModel(
            name='User',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                (
                    'uuid',
                    models.CharField(
                        default=authentic2.utils.misc.get_hex_uuid,
                        editable=False,
                        max_length=32,
                        unique=True,
                        verbose_name='uuid',
                    ),
                ),
                (
                    'username',
                    models.CharField(
                        blank=True, db_index=True, max_length=256, null=True, verbose_name='username'
                    ),
                ),
                ('first_name', models.CharField(blank=True, max_length=128, verbose_name='first name')),
                ('last_name', models.CharField(blank=True, max_length=128, verbose_name='last name')),
                (
                    'email',
                    models.EmailField(
                        blank=True,
                        max_length=254,
                        validators=[authentic2.validators.EmailValidator()],
                        verbose_name='email address',
                    ),
                ),
                ('email_verified', models.BooleanField(default=False, verbose_name='email verified')),
                (
                    'email_verified_date',
                    models.DateTimeField(
                        blank=True, default=None, null=True, verbose_name='email verified date'
                    ),
                ),
                (
                    'email_verified_sources',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(max_length=63),
                        blank=True,
                        default=list,
                        null=True,
                        size=None,
                        verbose_name='email verification sources',
                    ),
                ),
                (
                    'is_superuser',
                    models.BooleanField(
                        default=False,
                        help_text='Designates that this user has all permissions without explicitly assigning them.',
                        verbose_name='superuser status',
                    ),
                ),
                (
                    'phone',
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        validators=[authentic2.validators.PhoneNumberValidator],
                        verbose_name='phone number',
                    ),
                ),
                (
                    'phone_verified_on',
                    models.DateTimeField(
                        blank=True, default=None, null=True, verbose_name='phone verification date'
                    ),
                ),
                (
                    'is_staff',
                    models.BooleanField(
                        default=False,
                        help_text='Designates whether the user can log into this admin site.',
                        verbose_name='staff status',
                    ),
                ),
                (
                    'is_active',
                    models.BooleanField(
                        default=True,
                        help_text='Designates whether this user should be treated as active. Unselect this instead of deleting accounts.',
                        verbose_name='active',
                    ),
                ),
                (
                    'date_joined',
                    models.DateTimeField(default=django.utils.timezone.now, verbose_name='date joined'),
                ),
                (
                    'modified',
                    models.DateTimeField(auto_now=True, db_index=True, verbose_name='Last modification time'),
                ),
                (
                    'last_account_deletion_alert',
                    models.DateTimeField(blank=True, null=True, verbose_name='Last account deletion alert'),
                ),
                (
                    'deactivation',
                    models.DateTimeField(blank=True, null=True, verbose_name='Deactivation datetime'),
                ),
                (
                    'deactivation_reason',
                    models.TextField(blank=True, null=True, verbose_name='Deactivation reason'),
                ),
                (
                    'keepalive',
                    models.DateTimeField(blank=True, null=True, verbose_name='Keepalive timestamp'),
                ),
                (
                    'groups',
                    models.ManyToManyField(
                        blank=True,
                        help_text='The groups this user belongs to. A user will get all permissions granted to each of his/her group.',
                        related_name='user_set',
                        related_query_name='user',
                        to='auth.Group',
                        verbose_name='groups',
                    ),
                ),
                (
                    'ou',
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to='a2_rbac.organizationalunit',
                        verbose_name='organizational unit',
                    ),
                ),
                (
                    'user_permissions',
                    models.ManyToManyField(
                        blank=True,
                        help_text='Specific permissions for this user.',
                        related_name='user_set',
                        related_query_name='user',
                        to='auth.Permission',
                        verbose_name='user permissions',
                    ),
                ),
            ],
            options={
                'verbose_name': 'user',
                'verbose_name_plural': 'users',
                'ordering': ('last_name', 'first_name', 'email', 'username'),
            },
        ),
        migrations.CreateModel(
            name='ServiceProfileType',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'profile_type',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE, to='custom_user.profiletype'
                    ),
                ),
                (
                    'service',
                    models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='authentic2.service'),
                ),
            ],
            options={
                'unique_together': {('service', 'profile_type')},
            },
        ),
        migrations.CreateModel(
            name='Profile',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('identifier', models.CharField(default='', max_length=256, verbose_name='identifier')),
                ('email', models.EmailField(blank=True, max_length=254, verbose_name='email address')),
                ('data', models.JSONField(blank=True, null=True, verbose_name='data')),
                (
                    'profile_type',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='profiles',
                        to='custom_user.profiletype',
                        verbose_name='profile type',
                    ),
                ),
                (
                    'user',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='profiles',
                        to='custom_user.user',
                        verbose_name='user',
                    ),
                ),
            ],
            options={
                'verbose_name': 'profile',
                'verbose_name_plural': 'profiles',
                'ordering': ('user', 'profile_type'),
                'unique_together': {('user', 'profile_type', 'identifier')},
            },
        ),
        migrations.AddField(
            model_name='profiletype',
            name='services',
            field=models.ManyToManyField(
                blank=True,
                related_name='_custom_user_profiletype_services_+',
                through='custom_user.ServiceProfileType',
                to='authentic2.Service',
                verbose_name='allowed services for this profile type',
            ),
        ),
        migrations.RunSQL(
            sql=[
                'CREATE EXTENSION IF NOT EXISTS unaccent SCHEMA public',
                'CREATE EXTENSION IF NOT EXISTS pg_trgm SCHEMA public',
                'CREATE OR REPLACE FUNCTION public.immutable_unaccent(text) RETURNS varchar AS $$ SELECT'
                " public.unaccent('public.unaccent',$1::text); $$ LANGUAGE 'sql' IMMUTABLE",
                'CREATE INDEX custom_user_name_gist_idx ON custom_user_user USING gist'
                " (LOWER(public.immutable_unaccent(first_name || ' ' || last_name)) public.gist_trgm_ops)",
            ],
            reverse_sql=[
                'DROP INDEX IF EXISTS custom_user_name_gist_idx',
                'DROP FUNCTION IF EXISTS public.immutable_unaccent(text)',
                'DROP EXTENSION IF EXISTS pg_trgm',
                'DROP EXTENSION IF EXISTS unaccent',
            ],
        ),
    ]
