# Generated by Django 3.2.23 on 2023-12-14 21:01

import uuid

import django.contrib.postgres.fields
import django.contrib.postgres.search
import django.db.models.manager
from django.db import migrations, models

import authentic2.utils.sms
import authentic2.validators


class Migration(migrations.Migration):
    replaces = [
        ('authentic2', '0001_initial'),
        ('authentic2', '0002_auto_20150320_1418'),
        ('authentic2', '0003_auto_20150409_1840'),
        ('authentic2', '0004_service'),
        ('authentic2', '0005_service_ou'),
        ('authentic2', '0006_conditional_slug_index'),
        ('authentic2', '0007_auto_20150523_0028'),
        ('authentic2', '0008_auto_20160204_1415'),
        ('authentic2', '0009_auto_20160211_2247'),
        ('authentic2', '0010_attributevalue_multiple'),
        ('authentic2', '0011_auto_20160211_2253'),
        ('authentic2', '0012_auto_20160211_2255'),
        ('authentic2', '0013_auto_20160211_2258'),
        ('authentic2', '0014_attributevalue_verified'),
        ('authentic2', '0015_auto_20160621_1711'),
        ('authentic2', '0016_attribute_disabled'),
        ('authentic2', '0017_modify_attribute_serialization'),
        ('authentic2', '0018_auto_20170524_0842'),
        ('authentic2', '0019_auto_20170309_1529'),
        ('authentic2', '0020_delete_federatedid'),
        ('authentic2', '0021_attribute_order'),
        ('authentic2', '0022_attribute_scopes'),
        ('authentic2', '0023_auto_20181031_0900'),
        ('authentic2', '0024_auto_20190617_1113'),
        ('authentic2', '0025_auto_20191009_1047'),
        ('authentic2', '0026_token'),
        ('authentic2', '0027_remove_deleteduser'),
        ('authentic2', '0028_trigram_unaccent_index'),
        ('authentic2', '0029_auto_20201013_1614'),
        ('authentic2', '0030_clean_admin_tools_tables'),
        ('authentic2', '0031_add_search_vector_to_attributes'),
        ('authentic2', '0032_initialize_search_vectors'),
        ('authentic2', '0033_recreate_immutable_unaccent'),
        ('authentic2', '0034_attribute_required_on_login'),
        ('authentic2', '0035_service_home_url'),
        ('authentic2', '0036_service_profile_types'),
        ('authentic2', '0037_auto_20220331_1513'),
        ('authentic2', '0038_make_service_ou_non_null'),
        ('authentic2', '0039_add_unique_attribute_constraint'),
        ('authentic2', '0040_add_external_guid'),
        ('authentic2', '0041_lock'),
        ('authentic2', '0042_api_client'),
        ('authentic2', '0043_api_client_description'),
        ('authentic2', '0044_apiclient_ou'),
        ('authentic2', '0044_auto_20220530_1426'),
        ('authentic2', '0045_auto_20221222_1013'),
        ('authentic2', '0045_auto_20230117_1513'),
        ('authentic2', '0045_smscode'),
        ('authentic2', '0046_runtimesetting'),
        ('authentic2', '0047_initialize_services_runtime_settings'),
        ('authentic2', '0048_rename_services_runtime_settings'),
        ('authentic2', '0049_apiclient_allowed_user_attributes'),
        ('authentic2', '0050_initialize_users_advanced_configuration'),
    ]

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name='APIClient',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('name', models.CharField(max_length=128, verbose_name='Name')),
                ('description', models.TextField(blank=True, verbose_name='Description')),
                ('identifier', models.CharField(max_length=256, verbose_name='Identifier')),
                ('password', models.CharField(max_length=256, verbose_name='Password')),
                (
                    'restrict_to_anonymised_data',
                    models.BooleanField(default=False, verbose_name='Restrict to anonymised data'),
                ),
            ],
            options={
                'verbose_name': 'APIClient',
                'verbose_name_plural': 'APIClient',
            },
        ),
        migrations.CreateModel(
            name='Attribute',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('label', models.CharField(max_length=63, unique=True, verbose_name='label')),
                ('description', models.TextField(blank=True, verbose_name='description')),
                ('name', models.SlugField(max_length=256, unique=True, verbose_name='name')),
                ('required', models.BooleanField(blank=True, default=False, verbose_name='required')),
                (
                    'asked_on_registration',
                    models.BooleanField(blank=True, default=False, verbose_name='asked on registration'),
                ),
                (
                    'user_editable',
                    models.BooleanField(blank=True, default=False, verbose_name='user editable'),
                ),
                ('user_visible', models.BooleanField(blank=True, default=False, verbose_name='user visible')),
                ('multiple', models.BooleanField(blank=True, default=False, verbose_name='multiple')),
                ('kind', models.CharField(max_length=16, verbose_name='kind')),
                ('disabled', models.BooleanField(blank=True, default=False, verbose_name='disabled')),
                ('searchable', models.BooleanField(blank=True, default=False, verbose_name='searchable')),
                (
                    'required_on_login',
                    models.BooleanField(blank=True, default=False, verbose_name='required on login'),
                ),
                (
                    'scopes',
                    models.CharField(
                        blank=True,
                        default='',
                        help_text='scopes separated by spaces',
                        max_length=256,
                        verbose_name='scopes',
                    ),
                ),
                ('order', models.PositiveIntegerField(default=0, verbose_name='order')),
            ],
            options={
                'verbose_name': 'attribute definition',
                'verbose_name_plural': 'attribute definitions',
                'ordering': ('order', 'id'),
                'base_manager_name': 'all_objects',
            },
            managers=[
                ('all_objects', django.db.models.manager.Manager()),
            ],
        ),
        migrations.CreateModel(
            name='AttributeValue',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('object_id', models.PositiveIntegerField(db_index=True, verbose_name='object identifier')),
                ('multiple', models.BooleanField(default=False, null=True)),
                ('content', models.TextField(db_index=True, verbose_name='content')),
                (
                    'search_vector',
                    django.contrib.postgres.search.SearchVectorField(editable=False, null=True),
                ),
                ('verified', models.BooleanField(default=False)),
                (
                    'verification_sources',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(max_length=63),
                        null=True,
                        size=None,
                        verbose_name='verification sources',
                    ),
                ),
                (
                    'last_verified_on',
                    models.DateTimeField(null=True, verbose_name='last verification timestamp'),
                ),
            ],
            options={
                'verbose_name': 'attribute value',
                'verbose_name_plural': 'attribute values',
                'ordering': ('attribute__order', 'id'),
            },
            managers=[
                ('all_objects', django.db.models.manager.Manager()),
            ],
        ),
        migrations.CreateModel(
            name='AuthenticationEvent',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('when', models.DateTimeField(auto_now=True, verbose_name='when')),
                ('who', models.CharField(max_length=80, verbose_name='who')),
                ('how', models.CharField(max_length=32, verbose_name='how')),
                ('nonce', models.CharField(max_length=255, verbose_name='nonce')),
            ],
            options={
                'verbose_name': 'authentication log',
                'verbose_name_plural': 'authentication logs',
            },
        ),
        migrations.CreateModel(
            name='AuthorizedRole',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
            ],
        ),
        migrations.CreateModel(
            name='Lock',
            fields=[
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='Creation date')),
                ('name', models.TextField(primary_key=True, serialize=False, verbose_name='Name')),
            ],
            options={
                'verbose_name': 'Lock',
                'verbose_name_plural': 'Lock',
            },
        ),
        migrations.CreateModel(
            name='LogoutUrl',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'logout_url',
                    models.URLField(
                        blank=True,
                        help_text='you can use a {} to pass the URL of the success icon, ex.: http://example.com/logout?next={}',
                        max_length=255,
                        null=True,
                        verbose_name='url',
                    ),
                ),
                (
                    'logout_use_iframe',
                    models.BooleanField(
                        default=False, verbose_name='use an iframe instead of an img tag for logout'
                    ),
                ),
                (
                    'logout_use_iframe_timeout',
                    models.PositiveIntegerField(
                        default=300,
                        help_text="if iframe logout is used, it's the time between the onload event for this iframe and the moment we "
                        'consider its loading to be really finished',
                        verbose_name='iframe logout timeout (ms)',
                    ),
                ),
                ('object_id', models.PositiveIntegerField(verbose_name='object identifier')),
            ],
            options={
                'verbose_name': 'logout URL',
                'verbose_name_plural': 'logout URL',
            },
        ),
        migrations.CreateModel(
            name='PasswordReset',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
            ],
            options={
                'verbose_name': 'password reset',
                'verbose_name_plural': 'password reset',
            },
        ),
        migrations.CreateModel(
            name='Service',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('name', models.CharField(max_length=128, verbose_name='name')),
                ('slug', models.SlugField(max_length=128, verbose_name='slug')),
                (
                    'unauthorized_url',
                    models.URLField(
                        blank=True, max_length=256, null=True, verbose_name='callback url when unauthorized'
                    ),
                ),
                ('home_url', models.URLField(blank=True, max_length=256, null=True, verbose_name='Home URL')),
                ('logo', models.ImageField(blank=True, upload_to='services/logos', verbose_name='Logo')),
                (
                    'colour',
                    models.CharField(
                        blank=True,
                        max_length=32,
                        null=True,
                        validators=[authentic2.validators.HexaColourValidator()],
                        verbose_name='Colour',
                    ),
                ),
            ],
            options={
                'verbose_name': 'base service model',
                'verbose_name_plural': 'base service models',
                'base_manager_name': 'objects',
            },
        ),
        migrations.CreateModel(
            name='Setting',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('key', models.CharField(max_length=128, unique=True, verbose_name='key')),
                ('value', models.JSONField(blank=True, verbose_name='value')),
            ],
        ),
        migrations.CreateModel(
            name='SMSCode',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'value',
                    models.CharField(
                        default=authentic2.utils.sms.create_sms_code,
                        editable=False,
                        max_length=32,
                        verbose_name='Identifier',
                    ),
                ),
                ('kind', models.CharField(max_length=32, verbose_name='Kind')),
                (
                    'phone',
                    models.CharField(
                        blank=True,
                        max_length=64,
                        null=True,
                        validators=[authentic2.validators.PhoneNumberValidator],
                        verbose_name='phone number',
                    ),
                ),
                ('url_token', models.UUIDField(default=uuid.uuid4, verbose_name='URL token')),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='Creation date')),
                ('expires', models.DateTimeField(verbose_name='Expires')),
                ('sent', models.BooleanField(default=False, verbose_name='SMS code sent')),
                ('fake', models.BooleanField(default=False, verbose_name='Is a fake code')),
            ],
        ),
        migrations.CreateModel(
            name='Token',
            fields=[
                (
                    'uuid',
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                        verbose_name='Identifier',
                    ),
                ),
                ('kind', models.CharField(max_length=32, verbose_name='Kind')),
                ('content', models.JSONField(blank=True, verbose_name='Content')),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='Creation date')),
                ('expires', models.DateTimeField(verbose_name='Expires')),
            ],
            options={
                'ordering': ('-expires', 'kind', 'uuid'),
            },
        ),
        migrations.CreateModel(
            name='UserExternalId',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('source', models.CharField(max_length=256, verbose_name='source')),
                ('external_id', models.CharField(max_length=256, null=True, verbose_name='external id')),
                ('external_guid', models.UUIDField(null=True, verbose_name='External GUID')),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='creation date')),
                ('updated', models.DateTimeField(auto_now=True, verbose_name='last update date')),
            ],
            options={
                'verbose_name': 'user external id',
                'verbose_name_plural': 'user external ids',
            },
        ),
    ]
