# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.db.models.deletion
from django.db import migrations, models

import authentic2.saml.fields
import authentic2.saml.models


class Migration(migrations.Migration):
    replaces = [
        ('saml', '0001_initial'),
        ('saml', '0002_auto_20150320_1245'),
        ('saml', '0002_ease_federation_migration'),
        ('saml', '0003_merge'),
        ('saml', '0004_auto_20150410_1438'),
        ('saml', '0005_make_liberty_provider_inherit_from_service'),
        ('saml', '0006_restore_foreign_keys'),
        ('saml', '0007_copy_service_ptr_id_to_old_id'),
        ('saml', '0008_alter_foreign_keys'),
        ('saml', '0009_auto'),
        ('saml', '0010_auto'),
        ('saml', '0011_auto'),
        ('saml', '0012_auto_20150526_2239'),
        ('saml', '0013_auto_20150617_1004'),
        ('saml', '0014_auto_20150617_1216'),
        ('saml', '0015_auto_20150915_2032'),
        ('saml', '0016_auto_20150915_2041'),
        ('saml', '0017_auto_20170710_1738'),
        ('saml', '0018_truncate_saml_keyvalue'),
        ('saml', '0019_auto_20200621_1558'),
        ('saml', '0020_libertysession_saml_libert_provide_39bb6c_idx'),
    ]

    initial = True

    dependencies = [
        ('authentic2', '0052_replace'),
        ('custom_user', '0037_replace'),
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='KeyValue',
            fields=[
                ('key', models.CharField(max_length=128, primary_key=True, serialize=False)),
                ('value', authentic2.saml.fields.PickledObjectField()),
                ('created', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'verbose_name': 'key value association',
                'verbose_name_plural': 'key value associations',
            },
        ),
        migrations.CreateModel(
            name='LibertyArtifact',
            fields=[
                ('creation', models.DateTimeField(auto_now_add=True)),
                ('artifact', models.CharField(max_length=128, primary_key=True, serialize=False)),
                ('content', models.TextField()),
                ('provider_id', models.CharField(max_length=256)),
            ],
            options={
                'verbose_name': 'SAML artifact',
                'verbose_name_plural': 'SAML artifacts',
            },
        ),
        migrations.CreateModel(
            name='LibertyFederation',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'name_id_format',
                    models.CharField(blank=True, max_length=100, null=True, verbose_name='NameIDFormat'),
                ),
                ('name_id_content', models.CharField(max_length=100, verbose_name='NameID')),
                (
                    'name_id_qualifier',
                    models.CharField(blank=True, max_length=256, null=True, verbose_name='NameQualifier'),
                ),
                (
                    'name_id_sp_name_qualifier',
                    models.CharField(blank=True, max_length=256, null=True, verbose_name='SPNameQualifier'),
                ),
                ('termination_notified', models.BooleanField(blank=True, default=False)),
                ('creation', models.DateTimeField(auto_now_add=True)),
                ('last_modification', models.DateTimeField(auto_now=True)),
                (
                    'user',
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to='custom_user.user',
                    ),
                ),
            ],
            options={
                'verbose_name': 'SAML federation',
                'verbose_name_plural': 'SAML federations',
            },
        ),
        migrations.CreateModel(
            name='LibertyProvider',
            fields=[
                (
                    'service_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authentic2.service',
                    ),
                ),
                ('entity_id', models.URLField(max_length=256, unique=True, verbose_name='Entity ID')),
                (
                    'entity_id_sha1',
                    models.CharField(blank=True, max_length=40, verbose_name='Entity ID SHA1'),
                ),
                ('metadata_url', models.URLField(blank=True, max_length=256, verbose_name='Metadata URL')),
                (
                    'protocol_conformance',
                    models.IntegerField(choices=[(3, 'SAML 2.0')], verbose_name='Protocol conformance'),
                ),
                ('metadata', models.TextField(validators=[authentic2.saml.models.metadata_validator])),
                (
                    'federation_source',
                    models.CharField(blank=True, max_length=64, null=True, verbose_name='Federation source'),
                ),
            ],
            options={
                'verbose_name': 'SAML provider',
                'verbose_name_plural': 'SAML providers',
                'ordering': ('service_ptr__name',),
            },
            bases=('authentic2.service',),
        ),
        migrations.CreateModel(
            name='SPOptionsIdPPolicy',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('name', models.CharField(max_length=80, unique=True, verbose_name='name')),
                ('enabled', models.BooleanField(db_index=True, default=False, verbose_name='Enabled')),
                (
                    'prefered_assertion_consumer_binding',
                    models.CharField(
                        choices=[
                            ('meta', 'Use the default from the metadata file'),
                            ('art', 'Artifact binding'),
                            ('post', 'POST binding'),
                        ],
                        default='meta',
                        max_length=4,
                        verbose_name='Prefered assertion consumer binding',
                    ),
                ),
                ('encrypt_nameid', models.BooleanField(default=False, verbose_name='Encrypt NameID')),
                ('encrypt_assertion', models.BooleanField(default=False, verbose_name='Encrypt Assertion')),
                (
                    'authn_request_signed',
                    models.BooleanField(default=False, verbose_name='Authentication request signed'),
                ),
                (
                    'idp_initiated_sso',
                    models.BooleanField(db_index=True, default=False, verbose_name='Allow IdP initiated SSO'),
                ),
                (
                    'default_name_id_format',
                    models.CharField(
                        choices=[
                            ('none', 'None'),
                            ('persistent', 'Persistent'),
                            ('transient', 'Transient'),
                            ('email', 'Email'),
                            ('username', 'Username (use with Google Apps)'),
                            ('uuid', 'UUID'),
                            ('edupersontargetedid', 'Use eduPersonTargetedID attribute'),
                        ],
                        default='none',
                        max_length=256,
                    ),
                ),
                (
                    'accepted_name_id_format',
                    authentic2.saml.fields.MultiSelectField(
                        blank=True,
                        choices=[
                            ('none', 'None'),
                            ('persistent', 'Persistent'),
                            ('transient', 'Transient'),
                            ('email', 'Email'),
                            ('username', 'Username (use with Google Apps)'),
                            ('uuid', 'UUID'),
                            ('edupersontargetedid', 'Use eduPersonTargetedID attribute'),
                        ],
                        max_length=1024,
                        verbose_name='NameID formats accepted',
                    ),
                ),
                (
                    'ask_user_consent',
                    models.BooleanField(
                        default=False, verbose_name='Ask user for consent when creating a federation'
                    ),
                ),
                (
                    'accept_slo',
                    models.BooleanField(
                        db_index=True, default=True, verbose_name='Accept to receive Single Logout requests'
                    ),
                ),
                (
                    'forward_slo',
                    models.BooleanField(default=True, verbose_name='Forward Single Logout requests'),
                ),
                (
                    'needs_iframe_logout',
                    models.BooleanField(
                        default=False,
                        help_text='logout URL are normally loaded inside an <img> HTML tag, some service provider need to use an iframe',
                        verbose_name='needs iframe logout',
                    ),
                ),
                (
                    'iframe_logout_timeout',
                    models.PositiveIntegerField(
                        default=300,
                        help_text="if iframe logout is used, it's the time between the onload event for this iframe and the moment we "
                        'consider its loading to be really finished',
                        verbose_name='iframe logout timeout',
                    ),
                ),
                (
                    'http_method_for_slo_request',
                    models.IntegerField(
                        choices=[(4, 'Redirect binding'), (5, 'SOAP binding')],
                        default=4,
                        verbose_name='HTTP binding for the SLO requests',
                    ),
                ),
                (
                    'federation_mode',
                    models.PositiveIntegerField(
                        choices=[(0, 'explicit'), (1, 'implicit')], default=0, verbose_name='federation mode'
                    ),
                ),
            ],
            options={
                'verbose_name': 'service provider options policy',
                'verbose_name_plural': 'service provider options policies',
            },
        ),
        migrations.CreateModel(
            name='LibertyServiceProvider',
            fields=[
                (
                    'liberty_provider',
                    models.OneToOneField(
                        on_delete=django.db.models.deletion.CASCADE,
                        primary_key=True,
                        related_name='service_provider',
                        serialize=False,
                        to='saml.libertyprovider',
                    ),
                ),
                ('enabled', models.BooleanField(db_index=True, default=False, verbose_name='Enabled')),
                (
                    'enable_following_sp_options_policy',
                    models.BooleanField(
                        default=False,
                        verbose_name='The following options policy will apply except if a policy for all service provider is defined.',
                    ),
                ),
                (
                    'users_can_manage_federations',
                    models.BooleanField(
                        blank=True, db_index=True, default=True, verbose_name='users can manage federation'
                    ),
                ),
            ],
            options={
                'verbose_name': 'SAML service provider',
                'verbose_name_plural': 'SAML service providers',
            },
        ),
        migrations.CreateModel(
            name='LibertySessionDump',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('django_session_key', models.CharField(max_length=128)),
                ('session_dump', models.TextField(blank=True)),
                ('kind', models.IntegerField(choices=[(0, 'sp'), (1, 'idp')])),
            ],
            options={
                'verbose_name': 'SAML session dump',
                'verbose_name_plural': 'SAML session dumps',
                'unique_together': {('django_session_key', 'kind')},
            },
        ),
        migrations.CreateModel(
            name='LibertySession',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('django_session_key', models.CharField(max_length=128)),
                ('session_index', models.CharField(max_length=80)),
                ('provider_id', models.CharField(max_length=256)),
                ('name_id_qualifier', models.CharField(max_length=256, null=True, verbose_name='Qualifier')),
                ('name_id_format', models.CharField(max_length=100, null=True, verbose_name='NameIDFormat')),
                ('name_id_content', models.CharField(max_length=100, verbose_name='NameID')),
                (
                    'name_id_sp_name_qualifier',
                    models.CharField(max_length=256, null=True, verbose_name='SPNameQualifier'),
                ),
                ('creation', models.DateTimeField(auto_now_add=True)),
                (
                    'federation',
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to='saml.libertyfederation',
                    ),
                ),
            ],
            options={
                'verbose_name': 'SAML session',
                'verbose_name_plural': 'SAML sessions',
            },
        ),
        migrations.CreateModel(
            name='SAMLAttribute',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('object_id', models.PositiveIntegerField(verbose_name='object identifier')),
                (
                    'name_format',
                    models.CharField(
                        choices=[('basic', 'Basic'), ('uri', 'URI'), ('unspecified', 'Unspecified')],
                        default='basic',
                        max_length=64,
                        verbose_name='name format',
                    ),
                ),
                (
                    'name',
                    models.CharField(
                        blank=True,
                        help_text='the local attribute name is used if left blank',
                        max_length=128,
                        verbose_name='name',
                    ),
                ),
                ('friendly_name', models.CharField(blank=True, max_length=64, verbose_name='friendly name')),
                ('attribute_name', models.CharField(max_length=64, verbose_name='attribute name')),
                ('enabled', models.BooleanField(blank=True, default=True, verbose_name='enabled')),
                (
                    'content_type',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='contenttypes.contenttype',
                        verbose_name='content type',
                    ),
                ),
            ],
            options={
                'unique_together': {
                    ('content_type', 'object_id', 'name_format', 'name', 'friendly_name', 'attribute_name')
                },
            },
        ),
        migrations.AddIndex(
            model_name='libertysession',
            index=models.Index(
                fields=['provider_id', 'django_session_key'], name='saml_libert_provide_39bb6c_idx'
            ),
        ),
        migrations.AddField(
            model_name='libertyserviceprovider',
            name='sp_options_policy',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name='sp_options_policy',
                to='saml.spoptionsidppolicy',
                verbose_name='service provider options policy',
            ),
        ),
        migrations.AddField(
            model_name='libertyfederation',
            name='sp',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.CASCADE,
                to='saml.libertyserviceprovider',
            ),
        ),
    ]
