# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.contrib.postgres.fields
import django.db.models.deletion
from django.db import migrations, models

import authentic2_auth_fc.models


class Migration(migrations.Migration):
    replaces = [
        ('authentic2_auth_fc', '0001_initial'),
        ('authentic2_auth_fc', '0002_auto_20200416_1439'),
        ('authentic2_auth_fc', '0003_fcaccount_order1'),
        ('authentic2_auth_fc', '0004_fcaccount_order2'),
        ('authentic2_auth_fc', '0005_fcauthenticator'),
        ('authentic2_auth_fc', '0006_auto_20220525_1409'),
        ('authentic2_auth_fc', '0007_auto_20220615_1002'),
        ('authentic2_auth_fc', '0008_fcauthenticator_link_by_email'),
    ]

    initial = True

    dependencies = [
        ('authenticators', '0020_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='FcAccount',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='created')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='modified')),
                ('sub', models.TextField(db_index=True, verbose_name='sub')),
                ('order', models.PositiveIntegerField(default=0, verbose_name='order')),
                ('token', models.TextField(default='{}', verbose_name='access token')),
                ('user_info', models.TextField(default='{}', null=True, verbose_name='access token')),
            ],
        ),
        migrations.CreateModel(
            name='FcAuthenticator',
            fields=[
                (
                    'baseauthenticator_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authenticators.baseauthenticator',
                    ),
                ),
                (
                    'platform',
                    models.CharField(
                        choices=[('prod', 'Production'), ('test', 'Integration')],
                        default='test',
                        max_length=4,
                        verbose_name='Platform',
                    ),
                ),
                (
                    'client_id',
                    models.CharField(
                        help_text='See <a href="https://partenaires.franceconnect.gouv.fr/fcp/fournisseur-service">FranceConnect partners site</a> '
                        'for getting client ID and secret.',
                        max_length=256,
                        verbose_name='Client ID',
                    ),
                ),
                ('client_secret', models.CharField(max_length=256, verbose_name='Client Secret')),
                (
                    'scopes',
                    django.contrib.postgres.fields.ArrayField(
                        base_field=models.CharField(
                            choices=[
                                ('given_name', 'given name (given_name)'),
                                ('gender', 'gender (gender)'),
                                ('birthdate', 'birthdate (birthdate)'),
                                ('birthcountry', 'birthcountry (birthcountry)'),
                                ('birthplace', 'birthplace (birthplace)'),
                                ('family_name', 'family name (family_name)'),
                                ('email', 'email (email)'),
                                ('preferred_username', 'usual family name (preferred_username)'),
                                ('identite_pivot', 'core id (identite_pivot)'),
                                ('profile', 'profile (profile)'),
                                ('birth', 'birth profile (birth)'),
                            ],
                            max_length=32,
                        ),
                        default=authentic2_auth_fc.models.get_default_scopes,
                        size=None,
                        verbose_name='Scopes',
                    ),
                ),
                ('link_by_email', models.BooleanField(default=True, verbose_name='Link by email address')),
            ],
            options={
                'verbose_name': 'FranceConnect',
            },
            bases=('authenticators.baseauthenticator',),
        ),
    ]
