# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.db.models.deletion
from django.db import migrations, models

import authentic2.utils.template
import authentic2_auth_oidc.models


class Migration(migrations.Migration):
    replaces = [
        ('authentic2_auth_oidc', '0001_initial'),
        ('authentic2_auth_oidc', '0002_oidcprovider_token_revocation_endpoint'),
        ('authentic2_auth_oidc', '0003_oidcprovider_show'),
        ('authentic2_auth_oidc', '0004_auto_20171017_1522'),
        ('authentic2_auth_oidc', '0005_oidcprovider_slug'),
        ('authentic2_auth_oidc', '0006_oidcprovider_claims_parameter_supported'),
        ('authentic2_auth_oidc', '0007_auto_20200317_1732'),
        ('authentic2_auth_oidc', '0008_auto_20201102_1142'),
        ('authentic2_auth_oidc', '0009_oidcprovider_baseauthenticator_ptr'),
        ('authentic2_auth_oidc', '0010_auto_20220413_1622'),
        ('authentic2_auth_oidc', '0011_auto_20220413_1632'),
        ('authentic2_auth_oidc', '0012_auto_20220524_1147'),
        ('authentic2_auth_oidc', '0013_auto_20220726_1714'),
        ('authentic2_auth_oidc', '0013_synchronization_fields'),
        ('authentic2_auth_oidc', '0014_auto_20220920_1614'),
        ('authentic2_auth_oidc', '0014_oidcprovider_passive_authn_supported'),
        ('authentic2_auth_oidc', '0015_auto_20220922_1152'),
        ('authentic2_auth_oidc', '0016_auto_20221019_1148'),
        ('authentic2_auth_oidc', '0017_oidcprovider_jwkset_url'),
    ]

    initial = True

    dependencies = [
        ('authenticators', '0020_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='OIDCAccount',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='creation date')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='last modification date')),
                ('sub', models.CharField(max_length=256, verbose_name='sub')),
            ],
        ),
        migrations.CreateModel(
            name='OIDCClaimMapping',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'claim',
                    models.CharField(
                        max_length=128,
                        validators=[authentic2.utils.template.validate_template],
                        verbose_name='claim',
                    ),
                ),
                ('attribute', models.CharField(max_length=64, verbose_name='attribute')),
                (
                    'verified',
                    models.PositiveIntegerField(
                        choices=[(0, 'not verified'), (1, 'verified claim'), (2, 'always verified')],
                        default=0,
                        verbose_name='verified',
                    ),
                ),
                ('required', models.BooleanField(blank=True, default=False, verbose_name='required')),
                (
                    'idtoken_claim',
                    models.BooleanField(blank=True, default=False, verbose_name='idtoken claim'),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='creation date')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='last modification date')),
            ],
            options={
                'verbose_name': 'Claim',
                'verbose_name_plural': 'Claims',
                'default_related_name': 'claim_mappings',
            },
        ),
        migrations.CreateModel(
            name='OIDCProvider',
            fields=[
                (
                    'baseauthenticator_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authenticators.baseauthenticator',
                    ),
                ),
                ('issuer', models.CharField(db_index=True, max_length=256, verbose_name='issuer')),
                ('client_id', models.CharField(max_length=128, verbose_name='client id')),
                ('client_secret', models.CharField(max_length=128, verbose_name='client secret')),
                (
                    'authorization_endpoint',
                    models.URLField(max_length=128, verbose_name='authorization endpoint'),
                ),
                ('token_endpoint', models.URLField(max_length=128, verbose_name='token endpoint')),
                ('userinfo_endpoint', models.URLField(max_length=128, verbose_name='userinfo endpoint')),
                (
                    'end_session_endpoint',
                    models.URLField(
                        blank=True, max_length=128, null=True, verbose_name='end session endpoint'
                    ),
                ),
                (
                    'token_revocation_endpoint',
                    models.URLField(
                        blank=True, max_length=128, null=True, verbose_name='token revocation endpoint'
                    ),
                ),
                ('scopes', models.CharField(blank=True, max_length=128, verbose_name='scopes')),
                (
                    'jwkset_json',
                    models.JSONField(
                        blank=True,
                        null=True,
                        validators=[authentic2_auth_oidc.models.validate_jwkset],
                        verbose_name='JSON WebKey set',
                    ),
                ),
                (
                    'idtoken_algo',
                    models.PositiveIntegerField(
                        choices=[(0, 'none'), (1, 'RSA'), (2, 'HMAC'), (3, 'EC')],
                        default=1,
                        verbose_name='IDToken signature algorithm',
                    ),
                ),
                (
                    'claims_parameter_supported',
                    models.BooleanField(default=False, verbose_name='Claims parameter supported'),
                ),
                (
                    'strategy',
                    models.CharField(
                        choices=[
                            (
                                'create',
                                'create if account matching on email address failed (matching '
                                "will fail if global and provider's ou-wise email uniqueness is deactivated)",
                            ),
                            ('find-uuid', 'use sub to find existing user through UUID'),
                            ('find-username', 'use sub to find existing user through username'),
                            (
                                'find-email',
                                'use email claim (or sub if claim is absent) to find existing user through email',
                            ),
                            ('none', 'none'),
                        ],
                        max_length=32,
                        verbose_name='strategy',
                    ),
                ),
                (
                    'max_auth_age',
                    models.PositiveIntegerField(blank=True, null=True, verbose_name='max authentication age'),
                ),
                (
                    'a2_synchronization_supported',
                    models.BooleanField(default=False, verbose_name='Authentic2 synchronization supported'),
                ),
                (
                    'last_sync_time',
                    models.DateTimeField(
                        blank=True, editable=False, null=True, verbose_name='Last synchronization time'
                    ),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='creation date')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='last modification date')),
                (
                    'passive_authn_supported',
                    models.BooleanField(default=True, verbose_name='Supports passive authentication'),
                ),
                (
                    'jwkset_url',
                    models.URLField(
                        blank=True,
                        help_text='This URL is usually part of the “well-known” URLs as per the OIDC specifications',
                        max_length=256,
                        default='',
                        verbose_name="URL of the provider's JSON WebKey Set",
                    ),
                ),
            ],
            options={
                'verbose_name': 'OpenID Connect',
            },
            bases=('authenticators.baseauthenticator',),
        ),
        migrations.AddConstraint(
            model_name='oidcprovider',
            constraint=models.UniqueConstraint(
                condition=models.Q(('issuer', ''), _negated=True),
                fields=('issuer',),
                name='unique_issuer_if_not_empty',
            ),
        ),
        migrations.AddField(
            model_name='oidcclaimmapping',
            name='authenticator',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='claim_mappings',
                to='authenticators.baseauthenticator',
            ),
        ),
        migrations.AddField(
            model_name='oidcaccount',
            name='provider',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='accounts',
                to='authentic2_auth_oidc.oidcprovider',
                verbose_name='provider',
            ),
        ),
    ]
