# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.db.models.deletion
from django.db import migrations, models

import authentic2_auth_saml.models


class Migration(migrations.Migration):
    replaces = [
        ('authentic2_auth_saml', '0001_initial'),
        ('authentic2_auth_saml', '0002_auto_20220608_1559'),
        ('authentic2_auth_saml', '0003_auto_20220726_1713'),
        ('authentic2_auth_saml', '0004_remove_samlauthenticator_login_hints'),
        (
            'authentic2_auth_saml',
            '0005_addroleaction_renameattributeaction_samlattributelookup_setattributeaction',
        ),
        ('authentic2_auth_saml', '0006_migrate_jsonfields'),
        ('authentic2_auth_saml', '0007_remove_jsonfields'),
        ('authentic2_auth_saml', '0008_auto_20220913_1105'),
        ('authentic2_auth_saml', '0009_statically_rename_attributes'),
        ('authentic2_auth_saml', '0010_delete_renameattributeaction'),
        ('authentic2_auth_saml', '0011_alter_authenticator_foreign_key'),
        ('authentic2_auth_saml', '0012_move_add_role_action'),
        ('authentic2_auth_saml', '0013_metadata_file_to_db'),
        ('authentic2_auth_saml', '0014_remove_samlauthenticator_metadata_path'),
    ]

    initial = True

    dependencies = [
        ('authenticators', '0020_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='SAMLAuthenticator',
            fields=[
                (
                    'baseauthenticator_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authenticators.baseauthenticator',
                    ),
                ),
                ('metadata_url', models.URLField(blank=True, max_length=300, verbose_name='Metadata URL')),
                (
                    'metadata_cache_time',
                    models.PositiveSmallIntegerField(default=3600, verbose_name='Metadata cache time'),
                ),
                (
                    'metadata_http_timeout',
                    models.PositiveSmallIntegerField(default=10, verbose_name='Metadata HTTP timeout'),
                ),
                (
                    'metadata',
                    models.TextField(
                        blank=True,
                        validators=[authentic2_auth_saml.models.validate_metadata],
                        verbose_name='Metadata (XML)',
                    ),
                ),
                (
                    'provision',
                    models.BooleanField(
                        default=True, verbose_name='Create user if their username does not already exists'
                    ),
                ),
                (
                    'verify_ssl_certificate',
                    models.BooleanField(
                        default=True,
                        help_text='Verify SSL certificate when doing HTTP requests, used when resolving artifacts.',
                        verbose_name='Verify SSL certificate',
                    ),
                ),
                (
                    'transient_federation_attribute',
                    models.CharField(
                        blank=True,
                        help_text='Name of an attribute to use in replacement of the NameID content when the NameID format is transient.',
                        max_length=64,
                        verbose_name='Transient federation attribute',
                    ),
                ),
                (
                    'realm',
                    models.CharField(
                        default='saml',
                        help_text='The default realm to associate to user, can be used in username template.',
                        max_length=32,
                        verbose_name='Realm (realm)',
                    ),
                ),
                (
                    'username_template',
                    models.CharField(
                        default='{attributes[name_id_content]}@{realm}',
                        help_text='The template to build and/or retrieve a user from its username based on received attributes, the syntax is '
                        'the one from the str.format() method of Python. Available variables are realm, idp (current settings for the idp issuing '
                        'the assertion), attributes. The default value is {attributes[name_id_content]}@{realm}. Another example could be '
                        '{atttributes[uid][0]} to set the passed username as the username of the newly created user.',
                        max_length=128,
                        verbose_name='Username template',
                    ),
                ),
                (
                    'name_id_policy_format',
                    models.CharField(
                        blank=True,
                        choices=[
                            ('', 'None'),
                            (
                                'urn:oasis:names:tc:SAML:2.0:nameid-format:persistent',
                                'Persistent (urn:oasis:names:tc:SAML:2.0:nameid-format:persistent)',
                            ),
                            (
                                'urn:oasis:names:tc:SAML:2.0:nameid-format:transient',
                                'Transient (urn:oasis:names:tc:SAML:2.0:nameid-format:transient)',
                            ),
                            (
                                'urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress',
                                'Email (urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress)',
                            ),
                            (
                                'urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified',
                                'Unspecified (urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified)',
                            ),
                        ],
                        help_text='The NameID format to request.',
                        max_length=64,
                        verbose_name='NameID policy format',
                    ),
                ),
                (
                    'name_id_policy_allow_create',
                    models.BooleanField(default=True, verbose_name='NameID policy allow create'),
                ),
                (
                    'force_authn',
                    models.BooleanField(
                        default=False,
                        help_text='Force authentication on each authentication request.',
                        verbose_name='Force authn',
                    ),
                ),
                (
                    'add_authnrequest_next_url_extension',
                    models.BooleanField(default=False, verbose_name='Add authnrequest next url extension'),
                ),
                (
                    'group_attribute',
                    models.CharField(
                        blank=True,
                        help_text='Name of the SAML attribute to map to Django group names (for example "role").',
                        max_length=32,
                        verbose_name='Group attribute',
                    ),
                ),
                (
                    'create_group',
                    models.BooleanField(
                        default=True,
                        help_text='Create group or only assign existing groups.',
                        verbose_name='Create group',
                    ),
                ),
                (
                    'error_url',
                    models.URLField(
                        blank=True,
                        help_text='URL for the continue link when authentication fails. If not set, the RelayState is used. If there is no '
                        'RelayState, application default login redirect URL is used.',
                        verbose_name='Error URL',
                    ),
                ),
                (
                    'error_redirect_after_timeout',
                    models.PositiveSmallIntegerField(
                        default=120,
                        help_text='Timeout in seconds before automatically redirecting the user to the continue URL when authentication has failed.',
                        verbose_name='Error redirect after timeout',
                    ),
                ),
                (
                    'authn_classref',
                    models.CharField(
                        blank=True,
                        help_text='Authorized authentication class references, separated by commas. Empty value means everything is authorized. '
                        'Authentication class reference must be obtained from the identity provider but should come from the SAML 2.0 '
                        'specification.',
                        max_length=512,
                        verbose_name='Authn classref',
                    ),
                ),
                (
                    'attribute_mapping',
                    models.JSONField(
                        blank=True,
                        default=dict,
                        help_text='Maps templates based on SAML attributes to field of the user model, for '
                        'example {"email": "attributes[mail][0]"}.',
                        verbose_name='Attribute mapping (deprecated)',
                    ),
                ),
                (
                    'superuser_mapping',
                    models.JSONField(
                        blank=True,
                        default=dict,
                        editable=False,
                        help_text='Gives superuser flags to user if a SAML attribute contains a given value, for example {"roles": "Admin"}.',
                        verbose_name='Superuser mapping',
                    ),
                ),
            ],
            options={
                'verbose_name': 'SAML',
            },
            bases=('authenticators.baseauthenticator',),
        ),
        migrations.CreateModel(
            name='SetAttributeAction',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('user_field', models.CharField(max_length=256, verbose_name='User field')),
                ('saml_attribute', models.CharField(max_length=1024, verbose_name='SAML attribute name')),
                (
                    'mandatory',
                    models.BooleanField(
                        default=False,
                        help_text='Login will also be denied if attribute has more than one value.',
                        verbose_name='Deny login if attribute is missing',
                    ),
                ),
                (
                    'authenticator',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='set_attribute_actions',
                        to='authenticators.baseauthenticator',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Set an attribute',
                'verbose_name_plural': 'Set attributes',
                'default_related_name': 'set_attribute_actions',
            },
        ),
        migrations.CreateModel(
            name='SAMLAttributeLookup',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('user_field', models.CharField(max_length=256, verbose_name='User field')),
                ('saml_attribute', models.CharField(max_length=1024, verbose_name='SAML attribute')),
                ('ignore_case', models.BooleanField(default=False, verbose_name='Ignore case')),
                (
                    'authenticator',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name='attribute_lookups',
                        to='authenticators.baseauthenticator',
                    ),
                ),
            ],
            options={
                'verbose_name': 'Attribute lookup',
                'verbose_name_plural': 'Lookup by attributes',
                'default_related_name': 'attribute_lookups',
            },
        ),
    ]
