# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.db.models.deletion
from django.db import migrations, models

import authentic2_idp_cas.models


class Migration(migrations.Migration):
    replaces = [
        ('authentic2_idp_cas', '0001_initial'),
        ('authentic2_idp_cas', '0002_auto_20150410_1438'),
        ('authentic2_idp_cas', '0003_auto_20150415_2223'),
        ('authentic2_idp_cas', '0004_create_services'),
        ('authentic2_idp_cas', '0005_alter_field_service_ptr'),
        ('authentic2_idp_cas', '0006_copy_proxy_m2m'),
        ('authentic2_idp_cas', '0007_alter_service'),
        ('authentic2_idp_cas', '0008_alter_foreign_keys'),
        ('authentic2_idp_cas', '0009_alter_related_models'),
        ('authentic2_idp_cas', '0010_copy_service_ptr_id_to_old_id'),
        ('authentic2_idp_cas', '0011_remove_old_id_restore_proxy'),
        ('authentic2_idp_cas', '0012_copy_service_proxy_to_m2m'),
        ('authentic2_idp_cas', '0013_delete_model_service_proxy2'),
        ('authentic2_idp_cas', '0014_auto_20151204_1606'),
        ('authentic2_idp_cas', '0015_auto_20170406_1825'),
    ]

    initial = True

    dependencies = [
        ('authentic2', '0051_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='Attribute',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('slug', models.SlugField(verbose_name='slug')),
                ('attribute_name', models.CharField(max_length=64, verbose_name='attribute name')),
                ('enabled', models.BooleanField(default=True, verbose_name='enabled')),
            ],
            options={
                'verbose_name': 'CAS attribute',
                'verbose_name_plural': 'CAS attributes',
            },
        ),
        migrations.CreateModel(
            name='Service',
            fields=[
                (
                    'service_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authentic2.service',
                    ),
                ),
                (
                    'logout_url',
                    models.URLField(
                        blank=True,
                        help_text='you can use a {} to pass the URL of the success icon, ex.: http://example.com/logout?next={}',
                        max_length=255,
                        null=True,
                        verbose_name='url',
                    ),
                ),
                (
                    'logout_use_iframe',
                    models.BooleanField(
                        default=False, verbose_name='use an iframe instead of an img tag for logout'
                    ),
                ),
                (
                    'logout_use_iframe_timeout',
                    models.PositiveIntegerField(
                        default=300,
                        help_text="if iframe logout is used, it's the time between the onload event "
                        'for this iframe and the moment we consider its loading to be really finished',
                        verbose_name='iframe logout timeout (ms)',
                    ),
                ),
                ('urls', models.TextField(verbose_name='urls')),
                ('identifier_attribute', models.CharField(max_length=64, verbose_name='attribute name')),
            ],
            options={
                'verbose_name': 'service',
                'verbose_name_plural': 'services',
            },
            bases=('authentic2.service', models.Model),
        ),
        migrations.CreateModel(
            name='Ticket',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'ticket_id',
                    models.CharField(
                        default=authentic2_idp_cas.models.make_uuid,
                        max_length=64,
                        unique=True,
                        verbose_name='ticket id',
                    ),
                ),
                ('renew', models.BooleanField(default=False, verbose_name='fresh authentication')),
                ('validity', models.BooleanField(default=False, verbose_name='valid')),
                ('service_url', models.TextField(blank=True, default='', verbose_name='service URL')),
                ('creation', models.DateTimeField(auto_now_add=True, verbose_name='creation')),
                ('expire', models.DateTimeField(blank=True, null=True, verbose_name='expire')),
                (
                    'session_key',
                    models.CharField(
                        blank=True,
                        db_index=True,
                        default='',
                        max_length=64,
                        verbose_name='django session key',
                    ),
                ),
                ('proxies', models.TextField(blank=True, default='', verbose_name='proxies')),
                (
                    'service',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='authentic2_idp_cas.service',
                        verbose_name='service',
                    ),
                ),
            ],
        ),
    ]
