# Generated by Django 3.2.23 on 2023-12-14 21:01

import django.core.validators
import django.db.models.deletion
from django.db import migrations, models

import authentic2_idp_oidc.models


class Migration(migrations.Migration):
    replaces = [
        ('authentic2_idp_oidc', '0001_initial'),
        ('authentic2_idp_oidc', '0002_auto_20170121_2346'),
        ('authentic2_idp_oidc', '0003_auto_20170329_1259'),
        ('authentic2_idp_oidc', '0004_auto_20170324_1426'),
        ('authentic2_idp_oidc', '0005_authorization_mode'),
        ('authentic2_idp_oidc', '0006_auto_20170720_1054'),
        ('authentic2_idp_oidc', '0007_oidcclient_has_api_access'),
        ('authentic2_idp_oidc', '0008_oidcclient_idtoken_duration'),
        ('authentic2_idp_oidc', '0009_auto_20180313_1156'),
        ('authentic2_idp_oidc', '0010_oidcclaim'),
        ('authentic2_idp_oidc', '0011_auto_20180808_1546'),
        ('authentic2_idp_oidc', '0012_auto_20200122_2258'),
        ('authentic2_idp_oidc', '0013_auto_20200630_1007'),
        ('authentic2_idp_oidc', '0014_auto_20201126_1812'),
        ('authentic2_idp_oidc', '0015_auto_20220304_0738'),
        ('authentic2_idp_oidc', '0016_remove_oidcclient_perform_sub_profile_substitution'),
        ('authentic2_idp_oidc', '0017_oidcaccesstoken_profile'),
        ('authentic2_idp_oidc', '0018_alter_oidcaccesstoken_uuid'),
        ('authentic2_idp_oidc', '0019_always_save_authorization'),
        ('authentic2_idp_oidc', '0020_add_pkce_fields'),
        ('authentic2_idp_oidc', '0021_oidcclient_pkce_code_challenge'),
    ]

    initial = True

    dependencies = [
        ('authentic2', '0051_replace'),
    ]

    operations = [
        migrations.CreateModel(
            name='OIDCAccessToken',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'uuid',
                    models.CharField(
                        db_index=True,
                        default=authentic2_idp_oidc.models.generate_uuid,
                        max_length=128,
                        verbose_name='uuid',
                    ),
                ),
                ('scopes', models.TextField(verbose_name='scopes')),
                ('session_key', models.CharField(blank=True, max_length=128, verbose_name='session key')),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='created')),
                ('expired', models.DateTimeField(null=True, verbose_name='expire')),
            ],
            bases=(authentic2_idp_oidc.models.SessionMixin, models.Model),
        ),
        migrations.CreateModel(
            name='OIDCAuthorization',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('client_id', models.PositiveIntegerField(verbose_name='client id')),
                ('scopes', models.TextField(verbose_name='scopes')),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='created')),
                ('expired', models.DateTimeField(verbose_name='expire')),
            ],
        ),
        migrations.CreateModel(
            name='OIDCClaim',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                ('name', models.CharField(blank=True, max_length=128, verbose_name='attribute name')),
                ('value', models.CharField(blank=True, max_length=128, verbose_name='value of attribute')),
                ('scopes', models.CharField(blank=True, max_length=128, verbose_name='attribute scopes')),
            ],
        ),
        migrations.CreateModel(
            name='OIDCClient',
            fields=[
                (
                    'service_ptr',
                    models.OneToOneField(
                        auto_created=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        parent_link=True,
                        primary_key=True,
                        serialize=False,
                        to='authentic2.service',
                    ),
                ),
                (
                    'client_id',
                    models.CharField(
                        default=authentic2_idp_oidc.models.generate_uuid,
                        max_length=255,
                        unique=True,
                        verbose_name='client id',
                    ),
                ),
                (
                    'client_secret',
                    models.CharField(
                        default=authentic2_idp_oidc.models.generate_uuid,
                        max_length=255,
                        verbose_name='client secret',
                    ),
                ),
                (
                    'idtoken_duration',
                    models.DurationField(
                        blank=True,
                        default=None,
                        null=True,
                        verbose_name='time during which the token is valid',
                    ),
                ),
                (
                    'access_token_duration',
                    models.DurationField(
                        blank=True,
                        default=None,
                        null=True,
                        verbose_name='time during which the access token is valid',
                    ),
                ),
                (
                    'authorization_mode',
                    models.PositiveIntegerField(
                        choices=[(1, 'authorization by service'), (2, 'authorization by ou'), (3, 'none')],
                        default=1,
                        verbose_name='authorization mode',
                    ),
                ),
                (
                    'authorization_flow',
                    models.PositiveIntegerField(
                        choices=[
                            (1, 'authorization code'),
                            (2, 'implicit/native'),
                            (3, 'resource owner password credentials'),
                        ],
                        default=1,
                        verbose_name='authorization flow',
                    ),
                ),
                (
                    'always_save_authorization',
                    models.BooleanField(
                        default=False,
                        help_text='do not display the “do not ask again” choice',
                        verbose_name='always save authorization',
                    ),
                ),
                (
                    'authorization_default_duration',
                    models.PositiveIntegerField(
                        default=0,
                        help_text='0 for default value (one year)',
                        verbose_name='duration of saved authorization (in days)',
                    ),
                ),
                (
                    'redirect_uris',
                    models.TextField(
                        validators=[authentic2_idp_oidc.models.validate_https_url],
                        verbose_name='redirect URIs',
                    ),
                ),
                (
                    'post_logout_redirect_uris',
                    models.TextField(
                        blank=True,
                        default='',
                        validators=[authentic2_idp_oidc.models.validate_https_url],
                        verbose_name='post logout redirect URIs',
                    ),
                ),
                ('sector_identifier_uri', models.URLField(blank=True, verbose_name='sector identifier URI')),
                (
                    'identifier_policy',
                    models.PositiveIntegerField(
                        choices=[
                            (1, 'uuid'),
                            (2, 'pairwise unreversible'),
                            (4, 'pairwise reversible'),
                            (3, 'email'),
                        ],
                        default=2,
                        verbose_name='identifier policy',
                    ),
                ),
                (
                    'scope',
                    models.TextField(
                        blank=True,
                        default='',
                        help_text='Permitted or default scopes (for credentials grant)',
                        verbose_name='resource owner credentials grant scope',
                    ),
                ),
                (
                    'idtoken_algo',
                    models.PositiveIntegerField(
                        choices=[(2, 'HMAC'), (1, 'RSA'), (3, 'EC')],
                        default=2,
                        verbose_name='IDToken signature algorithm',
                    ),
                ),
                ('has_api_access', models.BooleanField(default=False, verbose_name='has API access')),
                (
                    'activate_user_profiles',
                    models.BooleanField(
                        blank=True,
                        default=False,
                        verbose_name="activate users' juridical entity profiles management",
                    ),
                ),
                (
                    'frontchannel_logout_uri',
                    models.URLField(blank=True, verbose_name='frontchannel logout URI'),
                ),
                (
                    'frontchannel_timeout',
                    models.PositiveIntegerField(blank=True, null=True, verbose_name='frontchannel timeout'),
                ),
                (
                    'pkce_code_challenge',
                    models.BooleanField(
                        default=False,
                        help_text='If PKCE is mandatory, the only method accepted will be S256.',
                        verbose_name='Client MUST provide a PKCE code_challenge',
                    ),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='created')),
                ('modified', models.DateTimeField(auto_now=True, verbose_name='modified')),
            ],
            bases=('authentic2.service',),
        ),
        migrations.CreateModel(
            name='OIDCCode',
            fields=[
                (
                    'id',
                    models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID'),
                ),
                (
                    'uuid',
                    models.CharField(
                        default=authentic2_idp_oidc.models.generate_uuid, max_length=128, verbose_name='uuid'
                    ),
                ),
                ('scopes', models.TextField(verbose_name='scopes')),
                ('state', models.TextField(null=True, verbose_name='state')),
                ('nonce', models.TextField(null=True, verbose_name='nonce')),
                (
                    'redirect_uri',
                    models.TextField(
                        validators=[django.core.validators.URLValidator()], verbose_name='redirect URI'
                    ),
                ),
                ('session_key', models.CharField(max_length=128, verbose_name='session key')),
                ('auth_time', models.DateTimeField(verbose_name='auth time')),
                ('code_challenge', models.TextField(null=True, verbose_name='Code challenge')),
                (
                    'code_challenge_method',
                    models.IntegerField(
                        choices=[(1, 'plain'), (2, 'S256')],
                        default=1,
                        null=True,
                        verbose_name='Code challenge method',
                    ),
                ),
                ('created', models.DateTimeField(auto_now_add=True, verbose_name='created')),
                ('expired', models.DateTimeField(verbose_name='expire')),
                (
                    'client',
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to='authentic2_idp_oidc.oidcclient',
                        verbose_name='client',
                    ),
                ),
            ],
            bases=(authentic2_idp_oidc.models.SessionMixin, models.Model),
        ),
    ]
